import yaml
from Person import Person
import os


class Generator:
    @staticmethod
    def generatePersonFromTemplate(templateID):
        """generiert Person anhand einer uebergebenen ID aus dem "PersonTemplates" - Dokument (yaml syntax)"""
        with open(os.path.join(os.path.dirname(__file__), 'personTemplates.yaml'), "r") as TemplatesFile:
            person = Person()
            templates = yaml.load(TemplatesFile)
            for section in templates.get("PersonTypes"):
                if section == templateID:
                    for entryKey in templates.get("PersonTypes").get(templateID):
                        if entryKey in vars(person):
                            entryValue = templates.get("PersonTypes").get(templateID).get(entryKey)
                            if type(entryValue) is int:
                                exec("%s.%s=%d" % ("person", entryKey, entryValue))
                            else:
                                exec("%s.%s=%f" % ("person", entryKey, entryValue))
                    return person
        return None
