"""ganz simple lahme oberflaeche, die nur alles visualisieren soll, bis die pygame-GUI steht"""
from __future__ import division
from PoIs import Exit
import turtle


class TGUI(object):
    def __init__(self, w, h):
        self.height = h
        self.width = w
        turtle.setworldcoordinates(0, 0, w, h)
        turtle.speed('fastest')
        turtle.ht()
        turtle.tracer(0, 0)

    def update(self, simulation):
        turtle.clear()
        
        self.paintPersons(simulation)
        self.paintExits(simulation)
        self.paintObstakles(simulation)
#        self.paintDijkstra(simulation)
        
        turtle.update()
        
    def paintDijkstra(self, simulation):
        points= simulation.map_.idxToPoint
        turtle.pensize(1)
        turtle.pencolor('blue')
        for edge in simulation.map_.edgeList:
            turtle.pu()
            turtle.goto(points[edge[0]])
            turtle.pd()
            turtle.goto(points[edge[1]])
        turtle.pencolor('red')
        turtle.pensize(2)
            
    def paintObstakles(self, simulation):
        turtle.pensize(3)
        turtle.color('black')
        for obstacle in simulation.map_.obstacles:
            turtle.pu()
            corners = obstacle.pointList
            turtle.goto(corners[0])
            turtle.pd()
            for point in corners:
                turtle.goto(point)
            turtle.goto(corners[0])
            
    def paintExits(self, simulation):
        turtle.pu()
        for exit_ in simulation.map_.getExits():
            turtle.goto(exit_.getPosition())
            turtle.dot(10, 'green')
            
    def paintPersons(self, simulation):
        for p in simulation.persons:
            turtle.pu()
            turtle.goto(p.pos)
            turtle.dot(5, 'green')
            turtle.pd()
#            for point in p.sp:
#                try:
#                    turtle.goto(point[0],point[1])
#                except:
#                    pass
