from __future__ import division
from Simulation import Simulation
from Person import Person
from numpy import array
from Map import Map
from Personengenerierung.Generator import Generator
from random import randint
import pickle

sim = Simulation()
sim.map_ = Map.readFromFile('test.pkl')
sim.speed = .2

def findEmptyPos(x, y, w, h):
    while True:
        xpos = randint(x, x + w)
        ypos = randint(y, y + h)
        pos = array([xpos,ypos])
        if sim.map_.pointIsAvailable(pos):
            return pos
        
i = 50

while len(sim.persons) < i:
    person = Generator.generatePersonFromTemplate(randint(1,2))
    person.setPosition(findEmptyPos(450,450,500,500))
    sim.addPerson(person)

#sim.map_.setHeight(1200)
sim.map_.precomputeSP()
print(sim.map_.toExit)

with open('MapTestPickle.pkl', 'wb') as output:
        pickle.dump(sim.map_, output, pickle.HIGHEST_PROTOCOL)


sim.start()
