from __future__ import division
from numpy import array
import numpy.linalg as LA
from numpy import inner

EPS=0.0000001

###diese klasse gehoert stefan.
# sie wird nur zum testen genutzt
# also: Alle anderen Finger weg!

def simpleFall(person, timestep):
    d = person.last_move
    accel= timestep*0.01*array((0,-1))
    return d + accel

def complicatedFall(person, timestep, enviroment):
    d= simpleFall(person, timestep)
    for obstacle in enviroment:
        lot= obstacle.getLot(person.pos)
        dist= LA.norm(lot)/3
        force= -lot/pow(dist+EPS, 3)
        if inner(d,force) > 0:
            force=  force*.01
        d=d+force

    speed= LA.norm(d)/timestep
    factor= min(speed,person.maxSpeed)/speed
    return d*factor


def doMove(person, timestep, nearbyPeople, enviroment):
    """nearbyPeople sind alle personen in relevanter naehe. enviroment ist eine liste aller hindernisse in relevanter naehe"""
    return complicatedFall(person, timestep, enviroment)
